/***************************************************************************
                          ExtensionsData.cpp  -  description
                             -------------------
    begin                : Tue Jan 25 2000
    copyright            : (C) 2000 by Yoan Adida
    email                : yoan.adida@lip6.fr
 ***************************************************************************/
#include "ExtensionsData.h"

#define Inherited QWidget

ExtensionsData::ExtensionsData
(
	QWidget* parent,
	const char* name
)
	:
	Inherited( parent, name, 0 )
{
	ButtonGroup_Photo = new QButtonGroup( this, "ButtonGroup_Photo" );
	ButtonGroup_Photo->setGeometry( 10, 20, 200, 240 );
	ButtonGroup_Photo->setMinimumSize( 0, 0 );
	ButtonGroup_Photo->setMaximumSize( 32767, 32767 );
	ButtonGroup_Photo->setFocusPolicy( QWidget::NoFocus );
	ButtonGroup_Photo->setBackgroundMode( QWidget::PaletteBackground );
	ButtonGroup_Photo->setFontPropagation( QWidget::NoChildren );
	ButtonGroup_Photo->setPalettePropagation( QWidget::NoChildren );
	ButtonGroup_Photo->setFrameStyle( 49 );
	ButtonGroup_Photo->setLineWidth( 1 );
	ButtonGroup_Photo->setMidLineWidth( 0 );
	ButtonGroup_Photo->QFrame::setMargin( 0 );
	ButtonGroup_Photo->setTitle( i18n("Photo" ));
	ButtonGroup_Photo->setAlignment( 1 );
	ButtonGroup_Photo->setExclusive( FALSE );

	ButtonGroup_Sound = new QButtonGroup( this, "ButtonGroup_Sound" );
	ButtonGroup_Sound->setGeometry( 220, 20, 240, 90 );
	ButtonGroup_Sound->setMinimumSize( 0, 0 );
	ButtonGroup_Sound->setMaximumSize( 32767, 32767 );
	ButtonGroup_Sound->setFocusPolicy( QWidget::NoFocus );
	ButtonGroup_Sound->setBackgroundMode( QWidget::PaletteBackground );
	ButtonGroup_Sound->setFontPropagation( QWidget::NoChildren );
	ButtonGroup_Sound->setPalettePropagation( QWidget::NoChildren );
	ButtonGroup_Sound->setFrameStyle( 49 );
	ButtonGroup_Sound->setLineWidth( 1 );
	ButtonGroup_Sound->setMidLineWidth( 0 );
	ButtonGroup_Sound->QFrame::setMargin( 0 );
	ButtonGroup_Sound->setTitle( i18n("Sound" ));
	ButtonGroup_Sound->setAlignment( 1 );
	ButtonGroup_Sound->setExclusive( FALSE );

		
	ButtonGroup_Other = new QButtonGroup( this, "ButtonGroup_Other" );
	ButtonGroup_Other->setGeometry( 220, 120, 240, 140 );
	ButtonGroup_Other->setMinimumSize( 0, 0 );
	ButtonGroup_Other->setMaximumSize( 32767, 32767 );
	ButtonGroup_Other->setFocusPolicy( QWidget::NoFocus );
	ButtonGroup_Other->setBackgroundMode( QWidget::PaletteBackground );
	ButtonGroup_Other->setFontPropagation( QWidget::NoChildren );
	ButtonGroup_Other->setPalettePropagation( QWidget::NoChildren );
	ButtonGroup_Other->setFrameStyle( 49 );
	ButtonGroup_Other->setLineWidth( 1 );
	ButtonGroup_Other->setMidLineWidth( 0 );
	ButtonGroup_Other->QFrame::setMargin( 0 );
	ButtonGroup_Other->setTitle( i18n("Other" ));
	ButtonGroup_Other->setAlignment( 1 );
	ButtonGroup_Other->setExclusive( FALSE );

	PushButton_Fetch = new QPushButton( this, "PushButton_Fetch" );
	PushButton_Fetch->setGeometry( 10, 280, 100, 30 );
	PushButton_Fetch->setMinimumSize( 0, 0 );
	PushButton_Fetch->setMaximumSize( 32767, 32767 );
	connect( PushButton_Fetch, SIGNAL(clicked()), SLOT(slot_extensions_fetch()) );
	PushButton_Fetch->setFocusPolicy( QWidget::TabFocus );
	PushButton_Fetch->setBackgroundMode( QWidget::PaletteBackground );
	PushButton_Fetch->setFontPropagation( QWidget::NoChildren );
	PushButton_Fetch->setPalettePropagation( QWidget::NoChildren );
	PushButton_Fetch->setText( i18n("Fetch" ));
	PushButton_Fetch->setAutoRepeat( FALSE );
	PushButton_Fetch->setAutoResize( FALSE );
	PushButton_Fetch->setToggleButton( FALSE );
	PushButton_Fetch->setDefault( FALSE );
	PushButton_Fetch->setAutoDefault( FALSE );
	PushButton_Fetch->setIsMenuButton( FALSE );

	PushButton_Modifyimage = new QPushButton( this, "PushButton_Modifyimage" );
	PushButton_Modifyimage->setGeometry( 130, 280, 100, 30 );
	PushButton_Modifyimage->setMinimumSize( 0, 0 );
	PushButton_Modifyimage->setMaximumSize( 32767, 32767 );
	connect( PushButton_Modifyimage, SIGNAL(clicked()), SLOT(slot_extensions_modifyimage()) );
	PushButton_Modifyimage->setFocusPolicy( QWidget::TabFocus );
	PushButton_Modifyimage->setBackgroundMode( QWidget::PaletteBackground );
	PushButton_Modifyimage->setFontPropagation( QWidget::NoChildren );
	PushButton_Modifyimage->setPalettePropagation( QWidget::NoChildren );
	PushButton_Modifyimage->setText( i18n("Modify Image" ));
	PushButton_Modifyimage->setAutoRepeat( FALSE );
	PushButton_Modifyimage->setAutoResize( FALSE );
	PushButton_Modifyimage->setToggleButton( FALSE );
	PushButton_Modifyimage->setDefault( FALSE );
	PushButton_Modifyimage->setAutoDefault( FALSE );
	PushButton_Modifyimage->setIsMenuButton( FALSE );

	PushButton_Modifysound = new QPushButton( this, "PushButton_Modifysound" );
	PushButton_Modifysound->setGeometry( 250, 280, 100, 30 );
	PushButton_Modifysound->setMinimumSize( 0, 0 );
	PushButton_Modifysound->setMaximumSize( 32767, 32767 );
	connect( PushButton_Modifysound, SIGNAL(clicked()), SLOT(slot_extensions_modifysound()) );
	PushButton_Modifysound->setFocusPolicy( QWidget::TabFocus );
	PushButton_Modifysound->setBackgroundMode( QWidget::PaletteBackground );
	PushButton_Modifysound->setFontPropagation( QWidget::NoChildren );
	PushButton_Modifysound->setPalettePropagation( QWidget::NoChildren );
	PushButton_Modifysound->setText( i18n("Modify Sound" ));
	PushButton_Modifysound->setAutoRepeat( FALSE );
	PushButton_Modifysound->setAutoResize( FALSE );
	PushButton_Modifysound->setToggleButton( FALSE );
	PushButton_Modifysound->setDefault( FALSE );
	PushButton_Modifysound->setAutoDefault( FALSE );
	PushButton_Modifysound->setIsMenuButton( FALSE );

	PushButton_Modifyother = new QPushButton( this, "PushButton_Modifyother" );
	PushButton_Modifyother->setGeometry( 370, 280, 100, 30 );
	PushButton_Modifyother->setMinimumSize( 0, 0 );
	PushButton_Modifyother->setMaximumSize( 32767, 32767 );
	connect( PushButton_Modifyother, SIGNAL(clicked()), SLOT(slot_extensions_modifyother()) );
	PushButton_Modifyother->setFocusPolicy( QWidget::TabFocus );
	PushButton_Modifyother->setBackgroundMode( QWidget::PaletteBackground );
	PushButton_Modifyother->setFontPropagation( QWidget::NoChildren );
	PushButton_Modifyother->setPalettePropagation( QWidget::NoChildren );
	PushButton_Modifyother->setText( i18n("Modify Other" ));
	PushButton_Modifyother->setAutoRepeat( FALSE );
	PushButton_Modifyother->setAutoResize( FALSE );
	PushButton_Modifyother->setToggleButton( FALSE );
	PushButton_Modifyother->setDefault( FALSE );
	PushButton_Modifyother->setAutoDefault( FALSE );
	PushButton_Modifyother->setIsMenuButton( FALSE );

	PushButton_Soundplay = new QPushButton( this, "PushButton_Soundplay" );
	PushButton_Soundplay->setGeometry( 230, 40, 100, 30 );
	PushButton_Soundplay->setMinimumSize( 0, 0 );
	PushButton_Soundplay->setMaximumSize( 32767, 32767 );
	connect( PushButton_Soundplay, SIGNAL(clicked()), SLOT(slot_extensions_soundplay()) );
	PushButton_Soundplay->setFocusPolicy( QWidget::TabFocus );
	PushButton_Soundplay->setBackgroundMode( QWidget::PaletteBackground );
	PushButton_Soundplay->setFontPropagation( QWidget::NoChildren );
	PushButton_Soundplay->setPalettePropagation( QWidget::NoChildren );
	PushButton_Soundplay->setText( i18n("Play" ));
	PushButton_Soundplay->setAutoRepeat( FALSE );
	PushButton_Soundplay->setAutoResize( FALSE );
	PushButton_Soundplay->setToggleButton( FALSE );
	PushButton_Soundplay->setDefault( FALSE );
	PushButton_Soundplay->setAutoDefault( FALSE );
	PushButton_Soundplay->setIsMenuButton( FALSE );

	PushButton_Soundstop = new QPushButton( this, "PushButton_Soundstop" );
	PushButton_Soundstop->setGeometry( 350, 40, 100, 30 );
	PushButton_Soundstop->setMinimumSize( 0, 0 );
	PushButton_Soundstop->setMaximumSize( 32767, 32767 );
	connect( PushButton_Soundstop, SIGNAL(clicked()), SLOT(slot_extensions_soundstop()) );
	PushButton_Soundstop->setFocusPolicy( QWidget::TabFocus );
	PushButton_Soundstop->setBackgroundMode( QWidget::PaletteBackground );
	PushButton_Soundstop->setFontPropagation( QWidget::NoChildren );
	PushButton_Soundstop->setPalettePropagation( QWidget::NoChildren );
	PushButton_Soundstop->setText( i18n("Stop" ));
	PushButton_Soundstop->setAutoRepeat( FALSE );
	PushButton_Soundstop->setAutoResize( FALSE );
	PushButton_Soundstop->setToggleButton( FALSE );
	PushButton_Soundstop->setDefault( FALSE );
	PushButton_Soundstop->setAutoDefault( FALSE );
	PushButton_Soundstop->setIsMenuButton( FALSE );

	Other_Extension = new OtherExtension( this, "Other_Extension" );
	Other_Extension->setGeometry( 230, 140, 220, 110 );
	Other_Extension->setMinimumSize( 0, 0 );
	Other_Extension->setMaximumSize( 32767, 32767 );
	Other_Extension->setFocusPolicy( QWidget::NoFocus );
	Other_Extension->setBackgroundMode( QWidget::PaletteBackground );
	Other_Extension->setFontPropagation( QWidget::NoChildren );
	Other_Extension->setPalettePropagation( QWidget::NoChildren );

	Label_Photoinfo = new QLabel( this, "Label_Photoinfo" );
	Label_Photoinfo->setGeometry( 20, 220, 180, 30 );
	Label_Photoinfo->setMinimumSize( 0, 0 );
	Label_Photoinfo->setMaximumSize( 32767, 32767 );
	Label_Photoinfo->setFocusPolicy( QWidget::NoFocus );
	Label_Photoinfo->setBackgroundMode( QWidget::PaletteBackground );
	Label_Photoinfo->setFontPropagation( QWidget::NoChildren );
	Label_Photoinfo->setPalettePropagation( QWidget::NoChildren );
	Label_Photoinfo->setFrameStyle( 0 );
	Label_Photoinfo->setLineWidth( 1 );
	Label_Photoinfo->setMidLineWidth( 0 );
	Label_Photoinfo->QFrame::setMargin( 0 );
	Label_Photoinfo->setText( i18n("Photo Infos:" ));
	Label_Photoinfo->setAlignment( 289 );
	Label_Photoinfo->setMargin( -1 );

	QLabel* Label_Soundinfo;
	Label_Soundinfo = new QLabel( this, "Label_Soundinfo" );
	Label_Soundinfo->setGeometry( 230, 70, 220, 30 );
	Label_Soundinfo->setMinimumSize( 0, 0 );
	Label_Soundinfo->setMaximumSize( 32767, 32767 );
	Label_Soundinfo->setFocusPolicy( QWidget::NoFocus );
	Label_Soundinfo->setBackgroundMode( QWidget::PaletteBackground );
	Label_Soundinfo->setFontPropagation( QWidget::NoChildren );
	Label_Soundinfo->setPalettePropagation( QWidget::NoChildren );
	Label_Soundinfo->setFrameStyle( 0 );
	Label_Soundinfo->setLineWidth( 1 );
	Label_Soundinfo->setMidLineWidth( 0 );
	Label_Soundinfo->QFrame::setMargin( 0 );
	Label_Soundinfo->setText( i18n("Sound Infos:" ));
	Label_Soundinfo->setAlignment( 289 );
	Label_Soundinfo->setMargin( -1 );


	ButtonGroup_Sound->insert( PushButton_Soundplay );
	ButtonGroup_Sound->insert( PushButton_Soundstop );


	resize( 480,330 );
	setMinimumSize( 0, 0 );
	setMaximumSize( 32767, 32767 );
}


ExtensionsData::~ExtensionsData()
{
}
void ExtensionsData::slot_extensions_fetch()
{
}
void ExtensionsData::slot_extensions_modifyimage()
{
}
void ExtensionsData::slot_extensions_modifysound()
{
}
void ExtensionsData::slot_extensions_modifyother()
{
}
void ExtensionsData::slot_extensions_soundplay()
{
}
void ExtensionsData::slot_extensions_soundstop()
{
}

void ExtensionsData::slot_extensionsdata_apply()
{
emit signal_extensionsdata_apply(Strings);
}

void ExtensionsData::slot_extensionsdata_receiveextensions(QString this_string)
{
}
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
