/***************************************************************************
                          NameData.cpp  -  description
                             -------------------
    begin                : Tue Jan 25 2000
    copyright            : (C) 2000 by Yoan Adida
    email                : yoan.adida@lip6.fr
 ***************************************************************************/
#include "NameData.h"

#define Inherited KDialog

NameData::NameData
(
	QWidget* parent,
	const char* name
)
	:
	Inherited( parent, name, TRUE, 0 )
{
	Label_Title = new QLabel( this, "Label_Title" );
	Label_Title->setGeometry( 20, 20, 100, 30 );
	Label_Title->setMinimumSize( 0, 0 );
	Label_Title->setMaximumSize( 32767, 32767 );
	Label_Title->setFocusPolicy( QWidget::NoFocus );
	Label_Title->setBackgroundMode( QWidget::PaletteBackground );
	Label_Title->setFontPropagation( QWidget::NoChildren );
	Label_Title->setPalettePropagation( QWidget::NoChildren );
	Label_Title->setFrameStyle( 0 );
	Label_Title->setLineWidth( 1 );
	Label_Title->setMidLineWidth( 0 );
	Label_Title->QFrame::setMargin( 0 );
	Label_Title->setText( i18n("Title" ));
	Label_Title->setAlignment( 289 );
	Label_Title->setMargin( -1 );

	ComboBox_Title = new QComboBox( FALSE, this, "ComboBox_Title" );
	ComboBox_Title->setGeometry( 130, 20, 70, 30 );
	ComboBox_Title->setMinimumSize( 70, 30 );
	ComboBox_Title->setMaximumSize( 70, 30 );
	connect( ComboBox_Title, SIGNAL(activated(int)), SLOT(Validate_Title(int)) );
	connect( ComboBox_Title, SIGNAL(highlighted(int)), SLOT(Title(int)) );
	ComboBox_Title->setFocusPolicy( QWidget::StrongFocus );
	ComboBox_Title->setBackgroundMode( QWidget::PaletteBackground );
	ComboBox_Title->setFontPropagation( QWidget::AllChildren );
	ComboBox_Title->setPalettePropagation( QWidget::AllChildren );
	ComboBox_Title->setSizeLimit( 3 );
	ComboBox_Title->setAutoResize( FALSE );
	ComboBox_Title->insertItem( i18n("<None>" ));
	ComboBox_Title->insertItem( i18n("Dr." ));
	ComboBox_Title->insertItem( i18n("M." ));
	ComboBox_Title->insertItem( i18n("Me" ));
	ComboBox_Title->insertItem( i18n("Mgr" ));
	ComboBox_Title->insertItem( i18n("Mlle" ));
	ComboBox_Title->insertItem( i18n("MM." ));
	ComboBox_Title->insertItem( i18n("P." ));
	ComboBox_Title->insertItem( i18n("Pr." ));
	ComboBox_Title->insertItem( i18n("Sr" ));
	ComboBox_Title->setMaxCount( 2147483647 );
	ComboBox_Title->setAutoCompletion( FALSE );

	Label_First_Name = new QLabel( this, "Label_First_Name" );
	Label_First_Name->setGeometry( 20, 60, 100, 30 );
	Label_First_Name->setMinimumSize( 0, 0 );
	Label_First_Name->setMaximumSize( 32767, 32767 );
	Label_First_Name->setFocusPolicy( QWidget::NoFocus );
	Label_First_Name->setBackgroundMode( QWidget::PaletteBackground );
	Label_First_Name->setFontPropagation( QWidget::NoChildren );
	Label_First_Name->setPalettePropagation( QWidget::NoChildren );
	Label_First_Name->setFrameStyle( 0 );
	Label_First_Name->setLineWidth( 1 );
	Label_First_Name->setMidLineWidth( 0 );
	Label_First_Name->QFrame::setMargin( 0 );
	Label_First_Name->setText( i18n("First Name" ));
	Label_First_Name->setAlignment( 289 );
	Label_First_Name->setMargin( -1 );

	LineEdit_First_Name = new QLineEdit( this, "LineEdit_First_Name" );
	LineEdit_First_Name->setGeometry( 130, 60, 190, 30 );
	LineEdit_First_Name->setMinimumSize( 0, 0 );
	LineEdit_First_Name->setMaximumSize( 32767, 32767 );
	connect( LineEdit_First_Name, SIGNAL(returnPressed()), SLOT(Validate_First_Name()) );
	connect( LineEdit_First_Name, SIGNAL(textChanged(const char*)), SLOT(First_Name(const char*)) );
	LineEdit_First_Name->setFocusPolicy( QWidget::StrongFocus );
	LineEdit_First_Name->setBackgroundMode( QWidget::PaletteBase );
	LineEdit_First_Name->setFontPropagation( QWidget::NoChildren );
	LineEdit_First_Name->setPalettePropagation( QWidget::NoChildren );
	LineEdit_First_Name->setText( "" );
	LineEdit_First_Name->setMaxLength( 256 );
	LineEdit_First_Name->setFrame( QLineEdit::Normal );
	LineEdit_First_Name->setFrame( TRUE );

	Label_Second_Name = new QLabel( this, "Label_Second_Name" );
	Label_Second_Name->setGeometry( 20, 100, 100, 30 );
	Label_Second_Name->setMinimumSize( 0, 0 );
	Label_Second_Name->setMaximumSize( 32767, 32767 );
	Label_Second_Name->setFocusPolicy( QWidget::NoFocus );
	Label_Second_Name->setBackgroundMode( QWidget::PaletteBackground );
	Label_Second_Name->setFontPropagation( QWidget::NoChildren );
	Label_Second_Name->setPalettePropagation( QWidget::NoChildren );
	Label_Second_Name->setFrameStyle( 0 );
	Label_Second_Name->setLineWidth( 1 );
	Label_Second_Name->setMidLineWidth( 0 );
	Label_Second_Name->QFrame::setMargin( 0 );
	Label_Second_Name->setText( i18n("Second Name" ));
	Label_Second_Name->setAlignment( 289 );
	Label_Second_Name->setMargin( -1 );

	LineEdit_Second_Name = new QLineEdit( this, "LineEdit_Second_Name" );
	LineEdit_Second_Name->setGeometry( 130, 100, 190, 30 );
	LineEdit_Second_Name->setMinimumSize( 0, 0 );
	LineEdit_Second_Name->setMaximumSize( 32767, 32767 );
	connect( LineEdit_Second_Name, SIGNAL(returnPressed()), SLOT(Validate_Second_Name()) );
	connect( LineEdit_Second_Name, SIGNAL(textChanged(const char*)), SLOT(Second_Name(const char*)) );
	LineEdit_Second_Name->setFocusPolicy( QWidget::StrongFocus );
	LineEdit_Second_Name->setBackgroundMode( QWidget::PaletteBase );
	LineEdit_Second_Name->setFontPropagation( QWidget::NoChildren );
	LineEdit_Second_Name->setPalettePropagation( QWidget::NoChildren );
	LineEdit_Second_Name->setText( "" );
	LineEdit_Second_Name->setMaxLength( 256 );
	LineEdit_Second_Name->setFrame( QLineEdit::Normal );
	LineEdit_Second_Name->setFrame( TRUE );

	Label_Last_Name = new QLabel( this, "Label_Last_Name" );
	Label_Last_Name->setGeometry( 20, 140, 100, 30 );
	Label_Last_Name->setMinimumSize( 0, 0 );
	Label_Last_Name->setMaximumSize( 32767, 32767 );
	Label_Last_Name->setFocusPolicy( QWidget::NoFocus );
	Label_Last_Name->setBackgroundMode( QWidget::PaletteBackground );
	Label_Last_Name->setFontPropagation( QWidget::NoChildren );
	Label_Last_Name->setPalettePropagation( QWidget::NoChildren );
	Label_Last_Name->setFrameStyle( 0 );
	Label_Last_Name->setLineWidth( 1 );
	Label_Last_Name->setMidLineWidth( 0 );
	Label_Last_Name->QFrame::setMargin( 0 );
	Label_Last_Name->setText( i18n("Last Name" ));
	Label_Last_Name->setAlignment( 289 );
	Label_Last_Name->setMargin( -1 );

	LineEdit_Last_Name = new QLineEdit( this, "LineEdit_Last_Name" );
	LineEdit_Last_Name->setGeometry( 130, 140, 190, 30 );
	LineEdit_Last_Name->setMinimumSize( 0, 0 );
	LineEdit_Last_Name->setMaximumSize( 32767, 32767 );
	connect( LineEdit_Last_Name, SIGNAL(returnPressed()), SLOT(Validate_Last_Name()) );
	connect( LineEdit_Last_Name, SIGNAL(textChanged(const char*)), SLOT(Last_Name(const char*)) );
	LineEdit_Last_Name->setFocusPolicy( QWidget::StrongFocus );
	LineEdit_Last_Name->setBackgroundMode( QWidget::PaletteBase );
	LineEdit_Last_Name->setFontPropagation( QWidget::NoChildren );
	LineEdit_Last_Name->setPalettePropagation( QWidget::NoChildren );
	LineEdit_Last_Name->setText( "" );
	LineEdit_Last_Name->setMaxLength( 256 );
	LineEdit_Last_Name->setFrame( QLineEdit::Normal );
	LineEdit_Last_Name->setFrame( TRUE );

	Label_Suffix = new QLabel( this, "Label_Suffix" );
	Label_Suffix->setGeometry( 20, 180, 100, 30 );
	Label_Suffix->setMinimumSize( 0, 0 );
	Label_Suffix->setMaximumSize( 32767, 32767 );
	Label_Suffix->setFocusPolicy( QWidget::NoFocus );
	Label_Suffix->setBackgroundMode( QWidget::PaletteBackground );
	Label_Suffix->setFontPropagation( QWidget::NoChildren );
	Label_Suffix->setPalettePropagation( QWidget::NoChildren );
	Label_Suffix->setFrameStyle( 0 );
	Label_Suffix->setLineWidth( 1 );
	Label_Suffix->setMidLineWidth( 0 );
	Label_Suffix->QFrame::setMargin( 0 );
	Label_Suffix->setText( i18n("Suffix" ));
	Label_Suffix->setAlignment( 289 );
	Label_Suffix->setMargin( -1 );

	ComboBox_Suffix = new QComboBox( FALSE, this, "ComboBox_Suffix" );
	ComboBox_Suffix->setGeometry( 130, 180, 70, 30 );
	ComboBox_Suffix->setMinimumSize( 70, 30 );
	ComboBox_Suffix->setMaximumSize( 70, 30 );
	connect( ComboBox_Suffix, SIGNAL(activated(int)), SLOT(Validate_Suffix(int)) );
	connect( ComboBox_Suffix, SIGNAL(highlighted(int)), SLOT(Suffix(int)) );
	ComboBox_Suffix->setFocusPolicy( QWidget::StrongFocus );
	ComboBox_Suffix->setBackgroundMode( QWidget::PaletteBackground );
	ComboBox_Suffix->setFontPropagation( QWidget::AllChildren );
	ComboBox_Suffix->setPalettePropagation( QWidget::AllChildren );
	ComboBox_Suffix->setSizeLimit( 6 );
	ComboBox_Suffix->setAutoResize( FALSE );
	ComboBox_Suffix->insertItem( i18n("<None>" ));
	ComboBox_Suffix->insertItem( i18n("I" ));
	ComboBox_Suffix->insertItem( i18n("II" ));
	ComboBox_Suffix->insertItem( i18n("III" ));
	ComboBox_Suffix->insertItem( i18n("Jr." ));
	ComboBox_Suffix->insertItem( i18n("Sr." ));
	ComboBox_Suffix->setMaxCount( 2147483647 );
	ComboBox_Suffix->setAutoCompletion( FALSE );

	PushButton_Validate = new QPushButton( this, "PushButton_Validate" );
	PushButton_Validate->setGeometry( 20, 220, 100, 30 );
	PushButton_Validate->setMinimumSize( 0, 0 );
	PushButton_Validate->setMaximumSize( 32767, 32767 );
	connect( PushButton_Validate, SIGNAL(clicked()), SLOT(Name_OK()) );
	PushButton_Validate->setFocusPolicy( QWidget::TabFocus );
	PushButton_Validate->setBackgroundMode( QWidget::PaletteBackground );
	PushButton_Validate->setFontPropagation( QWidget::NoChildren );
	PushButton_Validate->setPalettePropagation( QWidget::NoChildren );
	PushButton_Validate->setText( i18n("OK" ));
	PushButton_Validate->setAutoRepeat( FALSE );
	PushButton_Validate->setAutoResize( FALSE );
	PushButton_Validate->setToggleButton( FALSE );
	PushButton_Validate->setDefault( FALSE );
	PushButton_Validate->setAutoDefault( FALSE );
	PushButton_Validate->setIsMenuButton( FALSE );

	PushButton_Cancel = new QPushButton( this, "PushButton_Cancel" );
	PushButton_Cancel->setGeometry( 220, 220, 100, 30 );
	PushButton_Cancel->setMinimumSize( 0, 0 );
	PushButton_Cancel->setMaximumSize( 32767, 32767 );
	connect( PushButton_Cancel, SIGNAL(clicked()), SLOT(Name_Cancel()) );
	PushButton_Cancel->setFocusPolicy( QWidget::TabFocus );
	PushButton_Cancel->setBackgroundMode( QWidget::PaletteBackground );
	PushButton_Cancel->setFontPropagation( QWidget::NoChildren );
	PushButton_Cancel->setPalettePropagation( QWidget::NoChildren );
	PushButton_Cancel->setText( i18n("Cancel" ));
	PushButton_Cancel->setAutoRepeat( FALSE );
	PushButton_Cancel->setAutoResize( FALSE );
	PushButton_Cancel->setToggleButton( FALSE );
	PushButton_Cancel->setDefault( FALSE );
	PushButton_Cancel->setAutoDefault( FALSE );
	PushButton_Cancel->setIsMenuButton( FALSE );

	index_title=0;
	index_suffix=0;
	resize( 340,260 );
	setMinimumSize( 340, 260 );
	setMaximumSize( 340, 260 );
	this->setCaption(name);
	this->hide();
}


NameData::~NameData()
{
}
void NameData::Validate_Title(int this_int)
{
index_title=this_int;
}
void NameData::Title(int this_int)
{
index_title=this_int;
}
void NameData::Validate_First_Name()
{
}
void NameData::First_Name(const char*)
{
}
void NameData::Validate_Second_Name()
{
}
void NameData::Second_Name(const char*)
{
}
void NameData::Validate_Last_Name()
{
}
void NameData::Last_Name(const char*)
{
}
void NameData::Validate_Suffix(int this_int)
{
index_suffix=this_int;
}
void NameData::Suffix(int this_int)
{
index_suffix=this_int;
}
void NameData::Name_OK()
{
int i;
if (ComboBox_Title->text(index_title)!=QString(i18n("<None>")))
	{
	String.append(ComboBox_Title->text(index_title));
	String.append(" ");
	}
if (LineEdit_First_Name->text()!=QString(""))
	{
	String.append(LineEdit_First_Name->text());
	String.append(" ");
	}
if (LineEdit_Second_Name->text()!=QString(""))
	{
	String.append(LineEdit_Second_Name->text());
	String.append(" ");
	}
if (LineEdit_Last_Name->text()!=QString(""))
	{
	String.append(LineEdit_Last_Name->text());
	}
if (ComboBox_Suffix->text(index_suffix)!=QString(i18n("<None>")))
	{
	String.append(" ");
	String.append(ComboBox_Suffix->text(index_suffix));
	}
if (String!=QString(""))
	{
	emit signal_namedata_apply(String);
	}
delete (this);
}
void NameData::Name_Cancel()
{
delete (this);
}

void NameData::Load(QString this_string)
{
}
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
